package org.richfaces.testng;

import org.ajax4jsf.template.Template;
import org.richfaces.SeleniumTestBase;
import org.testng.annotations.Test;

public class AjaxListenerTest extends SeleniumTestBase {

    @Test(dataProvider = "templates")
    public void testAjaxListenerComponent(Template template) {
        renderPage(template);

        String parentId = getParentId() + "_form:";

        String inputElemId = parentId + "input";
        String outputElemId = parentId + "output";
        String ajaxSubmitElemId = outputElemId;

        writeStatus("Try to submit form with invalid input. In contrast to <f:actionListener> and "
                + "<f:valueChangeListener> ajax listener must be invoked anyway");

        clickAjaxCommandAndWait(ajaxSubmitElemId);
        AssertTextEquals(outputElemId, "Validation failed, but ajax listener is invoked anyway",
                "Ajax listener must be invoked even through validation failed");

        writeStatus("Correct input and try to submit again");
        type(inputElemId, "5");

        clickAjaxCommandAndWait(ajaxSubmitElemId);
        AssertTextEquals(outputElemId, "Ajax listener has been invoked successfully", "Ajax listener has not been invoked");

    }

    @Override
    public String getTestUrl() {
        return "pages/ajaxListener/ajaxListenerTest.xhtml";
    }

}
